using System;
using System.IO;
using System.Drawing;
using System.Reflection;
using System.Collections;
using System.Collections.Generic;

using SdlDotNet.Core;
using SdlDotNet.Graphics;
using SdlDotNet.Graphics.Sprites;
using SdlDotNet.Input;

using BoO.lib.obj;

namespace BoO.lib
{
    class collision
    {
        public static bool collide(Rectangle rec1, Rectangle rec2)
        {
            rec1 = new Rectangle(new Point(rec1.X, rec1.Y + rec1.Height - (BoO_Config.Main.standard_speed << 1)), new Size(rec1.Width, BoO_Config.Main.standard_speed << 1));

            if (rec1.IntersectsWith(rec2))
                return true;

            return false;
        }

        public static bool collide(Rectangle rec1, List<Rectangle> rec2)
        {
            for (int i = 0; i < rec2.Count; i++)
            {
                if(collide(rec1, rec2[i]))
                    return true;
            }

            return false;
        }

        public static objInteractive collide_with_objInteractive(Rectangle vrec)
        {
            objInteractive objI = null;

            Console.WriteLine("char: " + vrec);

            foreach (string strI in level._interact_images.Keys)
            {
                Console.WriteLine("objj: " + level._interact_images[strI].vrec);

                if (level._interact_images[strI].vrec.IntersectsWith(vrec))
                {
                    objI = level._interact_images[strI];
                }
            }

            return objI;
        }

        public static objInteractive collide_with_objInteractive_as_char(Rectangle vrec)
        {
            vrec = new Rectangle(new Point(vrec.X - BoO_Config.Main.standard_speed, vrec.Y + vrec.Height - (BoO_Config.Main.standard_speed << 1)), new Size(vrec.Width + (BoO_Config.Main.standard_speed << 1), BoO_Config.Main.standard_speed << 2));

            return collide_with_objInteractive(vrec);
        }
    }
}
