using System;
using System.IO;
using System.Drawing;
using System.Reflection;
using System.Collections;
using System.Collections.Generic;

using SdlDotNet.Core;
using SdlDotNet.Graphics;
using SdlDotNet.Graphics.Sprites;
using SdlDotNet.Input;

using BoO.lib.obj;

namespace BoO.lib.obj
{
    class background
    {
        private Surface _sur;
        private int[] slice;
        private int scrolling_speed;

        public Rectangle _tmp_col_check;

        public background(Surface s, int ss)
        {
            _sur = s;
            _sur.TransparentColor = BoO_Config.Video.transparent_color;
            _sur.Transparent = true;
            scrolling_speed = ss;

            slice = new int[4] { 0, BoO_Config.Video.res_h, 0, BoO_Config.Video.res_v };
        }

        public void move(Dictionary<string, bool> keys)
        {
            if (keys["left"] == true)
            {
                // Check if char collides with object
                _tmp_col_check = new Rectangle(new Point(BoO.share.main_char_vcoord.X - BoO.share.main_char_speed, BoO.share.main_char_vcoord.Y), BoO.share.main_char.Size);
                if (collision.collide(_tmp_col_check, level.collides))
                    return;

                if (this.slice[0] - scrolling_speed >= 0 && BoO.lib.calc.get_middle(BoO.share.main_char).X <= (BoO_Config.Video.res_h >> 1))
                {
                    this.slice[0] -= this.scrolling_speed;
                    this.slice[1] -= this.scrolling_speed;
                    BoOevents.events.bg_update = true;
                }
            }
            else if (keys["right"] == true)
            {
                // Check if char collides with object
                _tmp_col_check = new Rectangle(new Point(BoO.share.main_char_vcoord.X + BoO.share.main_char_speed, BoO.share.main_char_vcoord.Y), BoO.share.main_char.Size);
                if (collision.collide(_tmp_col_check, level.collides))
                    return;

                if (this.slice[1] + scrolling_speed <= _sur.Width && BoO.lib.calc.get_middle(BoO.share.main_char).X >= (BoO_Config.Video.res_h >> 1))
                {
                    this.slice[0] += this.scrolling_speed;
                    this.slice[1] += this.scrolling_speed;
                    BoOevents.events.bg_update = true;
                }
            }
            else if (keys["up"] == true)
            {
                // Check if char collides with object
                _tmp_col_check = new Rectangle(new Point(BoO.share.main_char_vcoord.X, BoO.share.main_char_vcoord.Y - BoO.share.main_char_speed), BoO.share.main_char.Size);
                if (collision.collide(_tmp_col_check, level.collides))
                    return;

                if (this.slice[2] - scrolling_speed >= 0 && BoO.lib.calc.get_middle(BoO.share.main_char).Y <= (BoO_Config.Video.res_v >> 1))
                {
                    this.slice[2] -= this.scrolling_speed;
                    this.slice[3] -= this.scrolling_speed;
                    BoOevents.events.bg_update = true;
                }
            }
            else if (keys["down"] == true)
            {
                // Check if char collides with object
                _tmp_col_check = new Rectangle(new Point(BoO.share.main_char_vcoord.X, BoO.share.main_char_vcoord.Y + BoO.share.main_char_speed), BoO.share.main_char.Size);
                if (collision.collide(_tmp_col_check, level.collides))
                    return;

                if (this.slice[3] + scrolling_speed <= _sur.Height && BoO.lib.calc.get_middle(BoO.share.main_char).Y >= (BoO_Config.Video.res_v >> 1))
                {
                    this.slice[2] += this.scrolling_speed;
                    this.slice[3] += this.scrolling_speed;
                    BoOevents.events.bg_update = true;
                }
            }

            BoO.share.map_coord = new Rectangle(this.slice[0], this.slice[2], this.slice[1], this.slice[3]);
        }

        public void render()
        {
            Video.Screen.Blit(_sur, new Point(0, 0), new Rectangle(this.slice[0], this.slice[2], this.slice[1], this.slice[3]));
        }

        public Surface surface
        {
            get
            {
                return _sur;
            }
        }
    }
}
